<?php
// vim: set ai ts=4 sw=4 ft=php:
namespace FreePBX\modules;
class Sipstation implements \BMO {

	public $ss = null;

	public function __construct($freepbx = null) {
		if ($freepbx == null) {
			throw new \Exception("Not given a FreePBX Object");
		}
		include(__DIR__.'/functions.inc/sipstation.inc.php');
		$this->ss = new \sipstation();
		$this->freepbx = $freepbx;
	}

	public function doConfigPageInit($page) {
	}

	public function install() {

	}
	public function uninstall() {

	}
	public function backup(){

	}
	public function restore($backup){

	}
	public function genConfig() {
	}

	public function processUCPAdminDisplay($user) {
		if(!empty($_REQUEST['ucp|sipstation-sms-did']) && $this->freepbx->Modules->checkStatus('sms')) {
			$this->freepbx->sms->addUserRouting($user['id'],$_REQUEST['ucp|sipstation-sms-did']);
		}
	}

	public function getDIDs($online = true) {
		$key = $this->ss->get_key();
		if(!empty($key)) {
			$c = $this->ss->get_config($key, $online);
			if(!empty($c['dids'])) {
				return $c['dids'];
			}
		}
		return array();
	}

	public function getUCPAdminDisplay($user) {
		if($this->freepbx->Modules->checkStatus('sms')) {
			$html['description'] = '<a href="#" class="info">'._("SIPStation SMS DIDs").':<span>'._("These are the SMS DIDs that are assigned to this user for use in UCP").'</span></a>';
			$html['content'] = load_view(dirname(__FILE__)."/views/ucp_config.php",array("dids" => $this->getDIDs(), "assigned" => $this->freepbx->sms->getAssignedDIDs($user['id'])));
		}
		return $html;
	}

	public function smsAdaptor() {
		include(__DIR__.'/functions.inc/SipstationSMS.class.php');
		return \FreePBX\modules\Sms\Adaptor\Sipstation::Create();
	}
}
